// bitfieldstest.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <Windows.h>
#include <stdint.h>
#include <setupapi.h>
extern "C"{
#include "ddk/hidsdi.h"
}

#include "hidapi.h"
#pragma comment(lib, "setupapi.lib")
#pragma comment(lib, "ddk/hid.lib")

//Hardcoded Logitech MOMO racing wheel, idea is that gamepad etc. would be selectable instead
#define PAD_VID			0x046D
#define PAD_PID			0xCA03

//extern OHCIState *qemu_ohci;
//unsigned char comp_data[6];
HANDLE usb_pad=(HANDLE)-1;
HANDLE readData=(HANDLE)-1;
OVERLAPPED ovl;

struct dfp_data_t
{
	uint32_t pad0 : 8;
	uint32_t axis_x : 14;
	uint32_t buttons_low : 14;
	// 32
	//uint32_t buttons_high : 4;
	uint32_t hatswitch : 4;
	uint32_t axis_y : 8;
	uint32_t axis_rz : 8;
	uint32_t pad1 : 8;
	//32

} dfp_data;

static const uint32_t data[] = {0x12345678, 0x2233445566};

int _tmain(int argc, _TCHAR* argv[])
{
	hid_device *dev = NULL;
	uint8_t buf2[] = {0x11, 0x08, 0x7E, 0x80, 0x0, 0x0, 0x0, 0x0};
	hid_init();

	int i=0;
	DWORD needed=0;
	char buf[64];
	HDEVINFO devInfo;
	GUID guid;
	SP_DEVICE_INTERFACE_DATA diData;
	PSP_DEVICE_INTERFACE_DETAIL_DATA didData;
	HIDD_ATTRIBUTES attr;

	readData=CreateEvent(0, 0, 0, 0);
	memset(&ovl, 0, sizeof(OVERLAPPED));
	ovl.hEvent=readData;
	ovl.Offset=0;
	ovl.OffsetHigh=0;

	HidD_GetHidGuid(&guid);
	
	devInfo=SetupDiGetClassDevs(&guid, 0, 0, DIGCF_DEVICEINTERFACE);
	if(!devInfo)return 0;
	
	diData.cbSize=sizeof(diData);

	while(SetupDiEnumDeviceInterfaces(devInfo, 0, &guid, i, &diData)){
		if(usb_pad!=INVALID_HANDLE_VALUE)CloseHandle(usb_pad);

		SetupDiGetDeviceInterfaceDetail(devInfo, &diData, 0, 0, &needed, 0);

		didData=(PSP_DEVICE_INTERFACE_DETAIL_DATA)malloc(needed);
		didData->cbSize=sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);
		if(!SetupDiGetDeviceInterfaceDetail(devInfo, &diData, didData, needed, 0, 0)){
			free(didData);
			break;
		}

		usb_pad=CreateFile(didData->DevicePath, GENERIC_READ|GENERIC_WRITE, 
			FILE_SHARE_READ|FILE_SHARE_WRITE, 0, OPEN_EXISTING, 
			//0 
			FILE_FLAG_OVERLAPPED
			, 0);
		if(usb_pad==INVALID_HANDLE_VALUE){
			//fprintf(stderr,"Could not open device %i\n", i);
			free(didData); 
			i++;
			continue;
		}

		PHIDP_PREPARSED_DATA pp_data;
		HIDP_CAPS caps;
		HidD_GetPreparsedData(usb_pad, &pp_data);
		HidP_GetCaps(pp_data, &caps);
		HidD_GetAttributes(usb_pad, &attr);

		fprintf(stderr, "Device %i : VID %04X PID %04X\n", i, attr.VendorID, attr.ProductID);

		if(caps.UsagePage == HID_USAGE_PAGE_GENERIC && 
			caps.Usage == HID_USAGE_GENERIC_JOYSTICK)
		{
		//if((attr.VendorID==PAD_VID) && attr.ProductID==PAD_PID){

			/*char path[MAX_PATH+1];
			wcstombs(path, didData->DevicePath, MAX_PATH);
			CloseHandle(usb_pad);
			printf("%s\n", path);
			dev = hid_open_path(path);*/

			//We've found our wheel !!!
			free(didData);
			fprintf(stderr, "Wheel found !!!\n");

			printf("OutputReportByteLength: %d\n", caps.OutputReportByteLength);
			printf("InputReportByteLength: %d\n", caps.InputReportByteLength);
			
			printf("NumberInputValueCaps: %d\n", caps.NumberInputValueCaps);
			printf("NumberInputDataIndices: %d\n", caps.NumberInputDataIndices);
			printf("NumberLinkCollectionNodes: %d\n", caps.NumberLinkCollectionNodes);
			printf("HidP_MaxDataListLength: %d\n", HidP_MaxDataListLength(HidP_Input, pp_data));
			
			ULONG node_len = caps.NumberLinkCollectionNodes * sizeof(HIDP_LINK_COLLECTION_NODE);
			PHIDP_LINK_COLLECTION_NODE pnode = (PHIDP_LINK_COLLECTION_NODE)malloc(node_len);
			
			HidP_GetLinkCollectionNodes(pnode, &node_len, pp_data);
			printf("LinkUsagePage: %X\n", pnode[0].LinkUsagePage);
			if(pnode[0].NumberOfChildren > 0)
				printf("LinkUsage: %X\n", pnode[pnode->NextSibling].LinkUsage);
			
			USHORT capsLength = caps.NumberInputButtonCaps, numberOfButtons = 0;

			PHIDP_BUTTON_CAPS pButtonCaps = 
				(PHIDP_BUTTON_CAPS)malloc(sizeof(HIDP_BUTTON_CAPS) * caps.NumberInputButtonCaps);

			if(HidP_GetButtonCaps(HidP_Input, pButtonCaps, &capsLength, pp_data) == HIDP_STATUS_SUCCESS )
				numberOfButtons = pButtonCaps->Range.UsageMax - pButtonCaps->Range.UsageMin + 1;
			printf("Buttons: %d\n", numberOfButtons);

			PHIDP_VALUE_CAPS pValueCaps
				= (PHIDP_VALUE_CAPS)malloc(sizeof(HIDP_VALUE_CAPS) * caps.NumberInputValueCaps);
				//= (PHIDP_VALUE_CAPS)HeapAlloc(hHeap, 0, sizeof(HIDP_VALUE_CAPS) * Caps.NumberInputValueCaps);
			
			ULONG value, read;
			USAGE usage[128];
			ZeroMemory(buf, 64);
			ReadFile(usb_pad, buf, caps.InputReportByteLength, &read, &ovl);
			
			DWORD waitRes = WaitForSingleObject(ovl.hEvent, 30);
			if(waitRes == WAIT_TIMEOUT || waitRes == WAIT_ABANDONED)
				CancelIo(usb_pad);
			printf("Read : %d\n" ,read);

			printf("Buttons:\n");
			ULONG usageLength = numberOfButtons;
			if(HidP_GetUsages(
					HidP_Input, pButtonCaps->UsagePage, 0, usage, &usageLength, pp_data,
					(PCHAR)buf, caps.InputReportByteLength) == HIDP_STATUS_SUCCESS )
			{
				// 10 from generic_data_t.buttons, maybe bring it to 12 bits
				for(ULONG i = 0; i < usageLength && i < 128; i++)
					printf("Button %d is pressed\n", usage[i] - pButtonCaps->Range.UsageMin);
			}

			capsLength = caps.NumberInputValueCaps;
			HidP_GetValueCaps(HidP_Input, pValueCaps, &capsLength, pp_data); //== HIDP_STATUS_SUCCESS )
			NTSTATUS status;
			for(int j=0; j < 50; j++)
			{
				for(i = 0; i < capsLength; i++)
				{
					if(
						(status = HidP_GetUsageValue(
							HidP_Input, pValueCaps[i].UsagePage, 0, 
							pValueCaps[i].Range.UsageMin, &value, pp_data,
							buf, caps.InputReportByteLength
						)) != HIDP_STATUS_SUCCESS )
					{
						printf("HidP_GetUsageValue failed %08X %X\n", status, pValueCaps[i].Range.UsageMin);
						continue;
					}
					printf("Min/max %d/%d\t", pValueCaps[i].LogicalMin, pValueCaps[i].LogicalMax);
					switch(pValueCaps[i].Range.UsageMin)
					{
						case 0x30:    // X-axis
							//lAxisX = (LONG)value - 128;
							printf("X: %d\n", value);
							break;

						case 0x31:    // Y-axis
							//lAxisY = (LONG)value - 128;
							printf("Y: %d\n", value);
							break;

						case 0x32: // Z-axis
							//lAxisZ = (LONG)value - 128;
							printf("Z: %d\n", value);
							break;

						case 0x33: // Rotate-X
							//lAxisRz = (LONG)value - 128;
							printf("Rx: %d\n", value);
							break;
					
						case 0x34: // Rotate-Y
							//lAxisRz = (LONG)value - 128;
							printf("Ry: %d\n", value);
							break;

						case 0x35: // Rotate-Z
							//lAxisRz = (LONG)value - 128;
							printf("Rz: %d\n", value);
							break;

						case 0x39:    // Hat Switch
							//lHat = value;
							printf("Hat: %02X\n", value);
							break;
						default:
							printf("<unhandled axis i:%d usage: %d  value: %d>\n", i, pValueCaps[i].Range.UsageMin, value);
							break;
					}
				}
				Sleep(100);
			}
			printf("\n");
			free(pnode);
			free(pValueCaps);
			free(pButtonCaps);
			
			
			//readData=CreateEvent(0, 0, 0, 0);
			//memset(&ovl, 0, sizeof(OVERLAPPED));
			ovl.hEvent=readData;
			ovl.Offset=0;
			ovl.OffsetHigh=0;

			Sleep(100);
			DWORD written = 0, err = 0, len;
			BOOL ret;
			uint8_t buf[] = {0, 0x11, 0x08, 0xa0, 0x80, 0x0, 0x0, 0x0, 0x0};
			len = sizeof(buf)/sizeof(buf[0]);

			len = 8;
			ResetEvent(ovl.hEvent);
			printf("Writing logitech FFB commands...\n");
			//ERROR_IO_PENDING
			for(int i = 0; i < 10; i++)
			{
				SetLastError(0);
				ret = WriteFile(usb_pad, buf, len, 0, &ovl);
				DWORD bResult = WaitForSingleObject(ovl.hEvent, 300);
				if(bResult == WAIT_TIMEOUT || bResult == WAIT_ABANDONED)
				{
					printf("taking too long, canceling.\n");
					CancelIo(usb_pad);
				}
				err = GetLastError();
				
				if(buf[3] == 0xa0)
				{
					buf[1] = 0x11;
					buf[3] = 0x60;
				}
				else
				{
					buf[1] = 0x11;
					buf[3] = 0xa0;
				}
				fprintf(stderr, "Written: %d, ret:%d err:%d res:%d\n", written, ret, err, bResult);
				Sleep(100);
			}

			//ERROR_INVALID_PARAMETER
			//fprintf(stderr, "Written: %d, ret:%d err:%d\n", written, ret, err);
			Sleep(1000);
			//reset?
			ZeroMemory(buf, len);
			//buf[0] = 0;
			buf[1] = 0x13;
			buf[3] = 0x0;
			SetLastError(0);
			//ret = WriteFile(usb_pad, buf, len, &written, &ovl)
			ret = WriteFile(usb_pad, buf, len, 0, &ovl);
			{
				DWORD Errorcode = GetLastError();
				// ensure it's ERROR_IO_PENDING
				//if(Errorcode == ERROR_IO_PENDING)
				//WaitForSingleObject(ovl.hEvent, INFINITE);
			}

			err = GetLastError();
			fprintf(stderr, "Written: %d, ret:%d err:%d\n", written, ret, err);
			Sleep(10);
			
			ZeroMemory(buf, 8);
			SetLastError(0);
			for(int i = 0; i<1; i++)
			{
				ret = ReadFile(usb_pad, buf, 8, &written, &ovl);
				err = GetLastError();
				fprintf(stderr, "Read: %d, ret:%d err:%d, %02X %02X %02X %02X\n", written, ret, err, buf[0],buf[1],buf[2],buf[3]);
				Sleep(500);
			}
			
			CloseHandle(usb_pad);
			break;
		}
		
		HidD_FreePreparsedData(pp_data);
		i++;
	}

	
	/*printf("dev: %s\n", dev);
	if(dev)
	{
		int ret = hid_write(dev, buf2, 8);
		printf("ret: %d\n", ret);
		hid_close(dev);
	}*/

	//memcpy(&dfp_data, data, 8);
	/*dfp_data.axis_x = 0x1122;
	dfp_data.axis_y = 0x44;
	dfp_data.axis_rz = 0x34;
	dfp_data.hatswitch = 7;
	printf("%X %X %X %X %X %X %X \n", dfp_data.pad0, dfp_data.axis_x, dfp_data.buttons_low, dfp_data.hatswitch, dfp_data.axis_y, dfp_data.axis_rz, dfp_data.pad1);*/
	printf("press <enter>...");
	getchar();
	return 0;
}

